--[[
maiInterface PROJECT branch RPG
---------------------------------------------------------------------
rpgbasic.lua
---------------------------------------------------------------------
Copyright (C) 2015-2016 iExploder(iexploder@mai-team.org)
All Rights Reserved for iExploder and other developers in mai-team.
---------------------------------------------------------------------
Consists: 	FFI C-language definitions(Video/Audio Basic Functions);
]]


ffi = require("ffi")
ffi.cdef[[


typedef int8_t Sint8;
typedef uint8_t Uint8;
typedef int16_t Sint16;
typedef uint16_t Uint16;
typedef int32_t Sint32;
typedef uint32_t Uint32;
typedef int64_t Sint64;
typedef uint64_t Uint64;

typedef struct
{
	Uint32 width;
	Uint32 height;
} ImageScale;

/* Graphics */
void LoadImage(const char* id, const char* path);
void UnloadImage(const char *id);
void DrawImage(const char* id, int srcX, int srcY, int srcW, int srcH, int dstX, int dstY, int dstW, int dstH, double angle);
void DrawImageSimple(const char* id, int dstX, int dstY, int dstW, int dstH);
void SetImageAlpha(const char* id, unsigned char alpha);
void Refresh();
void Sleep(Uint32 time);
void ClearBuffer();
ImageScale GetImageScale(const char* id);

/* Text */
void LoadFont(const char* path, int ptsize);
void RenderTextColor(const char* id, const char* text, Uint32 color, Uint32 width);
void RenderText(const char* id, const char* text, Uint32 width);

/* Events */
void EventRefresh();
Uint16 KeyState(Uint16 keyscancode);

/* Audio */
void LoadMusic(const char* id, const char* path);
void LoadChunk(const char* id, const char* path);
void PlayBGM(const char* id, int loops);
void StopBGM();
void PlayME(const char* id);
void PlaySE(const char* id);
void SetBGMVolume(double vol);
void SetMEVolume(double vol);
void SetSEVolume(double vol);

]]